import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:get/get.dart';
import 'package:wowit/firebaseService.dart';

abstract class BaseController extends GetxController {
  String collection;
  Map<String, List<dynamic>> dictCachedData = {};

  BaseController(
    this.collection,
  );

  @override
  void update([List<Object> ids, bool condition = true]) {
    // TODO: implement update
    super.update(ids, condition);
    print(this.runtimeType.toString() + ' - BaseController on update');
  }

  @override
  void onClose() {
    // TODO: implement onClose
    super.onClose();
    print(this.runtimeType.toString() + ' - BaseController on onClose');
  }

  @override
  void onReady() {
    // TODO: implement onReady
    super.onReady();
    print(this.runtimeType.toString() + ' - BaseController on onReady');
  }

  @override
  void onInit() {
    // TODO: implement onInit
    super.onInit();
    print(this.runtimeType.toString() +
        ' - BaseController on onInit with condition');
  }

  Stream<List<S>> onBindStream<S>(
      {Map<String, Object> conditions,
      Map<String, Object> orderBy,
      int limit = -1,
      bool usingDefaultCondition = true,
      String keyCachedData,
      bool forceReload = true}) {
    if (this.collection == '') {
      throw ("[ERROR] Collection is empty");
    }
    // TODO: implement onBindStream
    if (usingDefaultCondition != null && usingDefaultCondition) {
      if (conditions == null) conditions = {};
      if (!conditions.containsKey('statusData')) conditions['statusData'] = 3;
      if (!conditions.containsKey('visible')) conditions['visible'] = true;
    }
    bool isCached = keyCachedData != null && keyCachedData != "";
    if (isCached && !forceReload) //get data in cache
    {
      if (dictCachedData.containsKey(keyCachedData)) {
         //return onBeforeReturnResult(keyCachedData[keyCachedData]);// not support
      }
    }
    print(this.runtimeType.toString() +
        ' - BaseController on onBindStream - conditions: ' +
        conditions.toString());
    if (isCached) dictCachedData[keyCachedData] = [];
    return FirebaseService.getQuery(this.collection,
            conditions: conditions, orderBy: orderBy, limit: limit)
        .snapshots()
        .map((QuerySnapshot query) {
      List<S> retVal = [];
      query.docs.forEach((element) {
        dynamic item = toModel(element);
        retVal.add(item);
        if (isCached) dictCachedData[keyCachedData].add(item);
      });
      return onBeforeReturnResult(retVal);
    });
  }

  S toModel<S>(DocumentSnapshot element);

  List<S> onBeforeReturnResult<S>(List<S> retVal) {
    return retVal;
  }
}
